#include "ethernet.h"
#include "status_codes.h"
#include "conf_uart_serial.h"
#include "uart_serial.h"
#include "stdio_serial.h"
#include "tc.h"

#include "sysclk.h"
#include "lwip/opt.h"
#include "lwip/tcpip.h"

#include "lwip/stats.h"
#include "lwip/sys.h"
#include "lwip/api.h"
#include "lwip/sockets.h"

static uint8_t AppVersion[] = "V1.001 #";

void user_main(void)
{
	struct netconn *conn, *newconn;
	err_t err;
	struct netbuf *buf;
	void *data;
	u16_t len;

	printf("E01 TCP echo server %s(%s %s)\r\n", AppVersion, __DATE__, __TIME__);

	conn = netconn_new(NETCONN_TCP);
	if (conn == NULL) {
		printf("netconn_new failed:%s\r\n", lwip_strerr(err));
	}
	netconn_bind(conn, NULL, 4001);
	netconn_listen(conn);

	for( ;; )
	{
		err = netconn_accept(conn, &newconn);
		if (err == ERR_OK) {
			printf("%s\r\n", "accept");
			while (1) {
				err = netconn_recv(newconn, &buf);
				if (err == ERR_OK) {
					do {
						netbuf_data(buf, &data, &len);
						printf("netconn_recv:%d\r\n", len);
						err = netconn_write(newconn, data, len, NETCONN_COPY);
						if (err != ERR_OK) {
							printf("netconn_write:%s\r\n", lwip_strerr(err));
						}
					} while (netbuf_next(buf) >= 0);
					netbuf_delete(buf);
				} else {
					printf("%s\r\n", "close");
					netconn_close(newconn);
					netconn_delete(newconn);
					break;
				}
				vTaskDelay(1);
			}
		}
		vTaskDelay(1);
	}
}
