#include "ethernet.h"
#include "status_codes.h"
#include "conf_uart_serial.h"
#include "uart_serial.h"
#include "stdio_serial.h"
#include "tc.h"

#include "sysclk.h"
#include "lwip/opt.h"
#include "lwip/tcpip.h"

#include "lwip/stats.h"
#include "lwip/sys.h"
#include "lwip/api.h"
#include "lwip/sockets.h"
#include "RIO2014_RTC.h"

static uint8_t AppVersion[] = "V1.001 #";

/* Time string */
static uint8_t gs_uc_rtc_time[8 + 1] =
{ '0', '0', ':', '0', '0', ':', '0', '0', '\0' };
/* Date string */
static uint8_t gs_uc_date[10 + 1] =
{ '0', '0', '/', '0', '0', '/', '0', '0', '0', '0', '\0' };
/* Week string */
static uint8_t gs_uc_day_names[7][4] =
{ "Mon", "Tue", "Wed", "Thu", "Fri", "Sat", "Sun" };

void user_main(void)
{
	uint8_t u_hour, u_minute, u_second;
	uint8_t u_month, u_day, u_week;
	uint16_t us_year;
	
	printf("E02 RTC %s(%s %s)\r\n", AppVersion, __DATE__, __TIME__);
	printf("Set DHCP mode and NTP enable first please.\r\n");

	set_rtc_time(12, 00, 00);
	set_rtc_date(2015, 7, 30, 4);
	
	get_rtc_time(&u_hour, &u_minute, &u_second);
	get_rtc_date(&us_year, &u_month, &u_day, &u_week);
	printf("[Time/Date: %02u:%02u:%02u, %02u/%02u/%04u %s]\r\n",
		(uint16_t)u_hour, (uint16_t)u_minute, (uint16_t)u_second,
		(uint16_t)u_month, (uint16_t)u_day, us_year,
		gs_uc_day_names[u_week-1]);
	vTaskDelay(1000);	
	
	ntp_sync_now();
	for( ;; )
	{		
		get_rtc_time(&u_hour, &u_minute, &u_second);
		get_rtc_date(&us_year, &u_month, &u_day, &u_week);
		printf("[Time/Date: %02u:%02u:%02u, %02u/%02u/%04u %s]\r\n",
				(uint16_t)u_hour, (uint16_t)u_minute, (uint16_t)u_second,
				(uint16_t)u_month, (uint16_t)u_day, us_year,
				gs_uc_day_names[u_week-1]);		
		vTaskDelay(2000);
	}
}
