#include "ethernet.h"
#include "status_codes.h"
#include "conf_uart_serial.h"
#include "uart_serial.h"
#include "stdio_serial.h"
#include "tc.h"

#include "sysclk.h"
#include "lwip/opt.h"
#include "lwip/tcpip.h"

#include "lwip/stats.h"
#include "lwip/sys.h"
#include "lwip/api.h"
#include "lwip/sockets.h"
#include "RIO2014_DIO.h"

static uint8_t AppVersion[] = "V1.001 #";

static void show_dio_status(void)
{
	uint8_t i, val;
	
	for (i=1; i<=DI_SUM; i++) {
		val = get_di_value(i);
		printf("di#%d:%u,", i, val);
	}	
	printf("\r\n");
	for (i=1; i<=DO_SUM; i++) {
		val = get_do_value(i);
		printf("do#%d:%u,", i, val);
	}
	printf("\r\n");	
}

void user_main(void)
{
	uint8_t val;
	
	printf("E03 DIO %s(%s %s)\r\n", AppVersion, __DATE__, __TIME__);
	
	val = get_di_port_value();
	printf("get di port:0x%x\r\n", val);
	val = get_do_port_value();
	printf("get do port:0x%x\r\n", val);
		
	for( ;; )
	{
		printf("\r\nset do#1:%d\r\n", 0);
		set_do_value(1, 0);		
		vTaskDelay(1000);		
		show_dio_status();
		vTaskDelay(4000);		
		
		printf("\r\nset do#1:%d\r\n", 1);
		set_do_value(1, 1);		
		vTaskDelay(1000);
		show_dio_status();
		vTaskDelay(4000);		

		printf("\r\nset do#2:%d\r\n", 0);
		set_do_value(2, 0);		
		vTaskDelay(1000);
		show_dio_status();
		vTaskDelay(4000);		
		
		printf("\r\nset do#2:%d\r\n", 1);
		set_do_value(2, 1);		
		vTaskDelay(1000);
		show_dio_status();
		vTaskDelay(4000);		
	}
}
