﻿/*
 * RIO2014_EEPROM.h
 *
 * Created: 2015/9/2 下午 08:29:21
 *  Author: Ying
 */ 


#ifndef RIO2014_EEPROM_H_
#define RIO2014_EEPROM_H_


#define	EEPROM_OK						0x00
#define EEPROM_ERR_INVALID_ARGUMENT     0x01
#define EEPROM_ERR_ARBITRATION_LOST     0x02
#define EEPROM_ERR_NO_CHIP_FOUND        0x03
#define EEPROM_ERR_RECEIVE_OVERRUN      0x04
#define EEPROM_ERR_RECEIVE_NACK         0x05
#define EEPROM_ERR_SEND_OVERRUN         0x06
#define EEPROM_ERR_SEND_NACK            0x07
#define EEPROM_ERR_BUSY                 0x08
#define EEPROM_ERR_TIMEOUT				0x09
#define	EEPROM_ERR_INIT_FAILED			0x0A
#define	EEPROM_ERR_BUS_BUSY				0x0B
#define	EEPROM_ERR_ARG_ADDR				0x0C
#define	EEPROM_ERR_ARG_LENGTH			0x0D

uint8_t rio_eeprom_write_byte(uint16_t address, uint8_t data_byte);
uint8_t rio_eeprom_write_page(uint16_t address, uint8_t *data_buf, uint16_t len);
uint8_t rio_eeprom_read(uint16_t address, uint8_t *data_buf, uint16_t len);

#endif /* RIO2014_EEPROM_H_ */