﻿/*
 * RIO2014_AI.h
 *
 * Created: 2015/8/14 下午 12:48:40
 *  Author: Ying
 */ 


#ifndef RIO2014_AI_H_
#define RIO2014_AI_H_

#define AI_INPUT_MAX	4

#define AI_RANGE_0_150_MV		0x00	//0mV~150mV
#define AI_RANGE_0_500_MV		0x02	//0mV~500mV
#define AI_RANGE_0_1_V			0x04	//0V~1V
#define AI_RANGE_0_5_V			0x06
#define AI_RANGE_0_10_V			0x08
#define AI_RANGE_0_20_MA			0x0a

#define AI_RANGE_N150_150_MV	0x10	//-150mV~150mV
#define AI_RANGE_N500_500_MV	0x12	//-500mV~500mV
#define AI_RANGE_N1_1_V			0x14	//-1V~1V
#define AI_RANGE_N5_5_V			0x16
#define AI_RANGE_N10_10_V		0x18

#define AI_CHANNEL_DISABLE	0x00
#define AI_CHANNEL_ENABLE	0x01

#define	AI_OK			0x00
#define	AI_ERR_ARG_CHENNEL_NO	0x01
#define	AI_ERR_ARG_ENABLE	0x02
#define	AI_ERR_ARG_RANGE	0x03
#define	AI_ERR_CHANNEL_DISABLE	0x04
#define	AI_ERR_CHANNEL_VALUE_NOT_READY	0x05

uint8_t ai_channel_init(uint8_t enable, uint8_t channel_no, uint8_t range);
uint8_t ai_channel_get_value(uint8_t channel_no, unsigned long *value_long, uint8_t *polar_flag);

#endif /* RIO2014_AI_H_ */