#include <string.h>
#include "ethernet.h"
#include "status_codes.h"
#include "conf_uart_serial.h"
#include "uart_serial.h"
#include "stdio_serial.h"
#include "tc.h"

#include "sysclk.h"
#include "lwip/opt.h"
#include "lwip/tcpip.h"

#include "lwip/stats.h"
#include "lwip/sys.h"
#include "lwip/api.h"
#include "lwip/sockets.h"
#include "RIO2014.h"
#include "RIO2014_AI.h"

#define AI_CHANNEL_NO	1

static uint8_t AppVersion[] = "V1.001 #";

void show_ai_channel_value(void)
{
	uint8_t ret, float_str[16], polar_ch;	
	unsigned long value_long;
	float value_ft;
	
	ret = ai_channel_get_value(AI_CHANNEL_NO, &value_long, &polar_ch);
	if (ret != AI_OK) {
		printf("ai_channel_get_value failed:%d\r\n", ret);
		return;
	}
	value_ft = ((float)value_long) / 1000;
	ftoa(value_ft, float_str, 3);
	printf("CH#%d:%c%s\r\n", AI_CHANNEL_NO, polar_ch, float_str);
}
void user_main(void)
{
	printf("E11 AI %s(%s %s)\r\n", AppVersion, __DATE__, __TIME__);
	printf("AI#1 JP4 short pin1 and pin2, and then power on\r\n");	
	ai_channel_init(AI_CHANNEL_ENABLE, AI_CHANNEL_NO, AI_RANGE_0_10_V);
	
	for( ;; )
	{		
		show_ai_channel_value();
		vTaskDelay(5000);		
	}
}
