#include <string.h>
#include "ethernet.h"
#include "status_codes.h"
#include "conf_uart_serial.h"
#include "uart_serial.h"
#include "stdio_serial.h"
#include "tc.h"

#include "sysclk.h"
#include "lwip/opt.h"
#include "lwip/tcpip.h"

#include "lwip/stats.h"
#include "lwip/sys.h"
#include "lwip/api.h"
#include "lwip/sockets.h"
#include "RIO2014_1WIRE_SENSOR.h"
#include "RIO2014.h"

static uint8_t AppVersion[] = "V1.001 #";
static uint8_t sensor_id[8];
static float sensor_value;

extern void poll_temperature_sensor(void);

void show_sensor_value(void)
{
	uint8_t i, j, ret, float_str[16], sensor_count;
	float value_f;
	
	sensor_count = temperature_sensor_get_count();
	if (sensor_count == 0) {
		printf("No sensor online\r\n");
		return;
	}
	for (j=0; j<sensor_count; j++) {
		ret = temperature_sensor_get_value(j, &sensor_id, &sensor_value);
		if (ret != SENSOR_OK) {
			printf("get value failed:%d\r\n", ret);
			return;
		}
		printf("Sensor#%d ID:", j);
		for (i = 0; i < 8; i++){
			printf("%02X", sensor_id[i]);
		}
		ftoa(sensor_value, float_str, 2);
		printf("\r\n%s C, ", float_str);
		
		value_f = (float)(sensor_value*9/5);
		value_f += 32.000;
		ftoa(value_f, float_str, 2);
		printf("%s F\r\n", float_str);
	}
}
void user_main(void)
{
	uint8_t ret, respbuf[1];
	
	printf("E12 One Wire Sensor %s(%s %s)\r\n", AppVersion, __DATE__, __TIME__);
	
	ret = temperature_sensor_init();
	if (ret != SENSOR_OK) {
		printf("temperature_sensor_init failed:%d\r\n", ret);
		return;
	}
	
	for( ;; )
	{
		show_sensor_value();
		vTaskDelay(5000);				
	}
}
