#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "ethernet.h"
#include "status_codes.h"
#include "conf_uart_serial.h"
#include "uart_serial.h"
#include "stdio_serial.h"
#include "tc.h"

#include "sysclk.h"
#include "lwip/opt.h"
#include "lwip/tcpip.h"

#include "lwip/stats.h"
#include "lwip/sys.h"
#include "lwip/api.h"
#include "lwip/sockets.h"
#include "RIO2014_Web.h"
#include "RIO2014_SYSTEM.h"
#include "RIO2014_USART.h"
#include "web_ajax.h"

#define USART_PORT_1		USART0	//RS-485 Only

static uint8_t AppVersion[] = "V1.001 #";

static unsigned short web_file_open(char *name, char *arg, char *ptr_data_buf)
{
	if (strstr(name, "/wapi/v1/fetchConfig") != 0) {
		return (fetch_config(ptr_data_buf));
	} else if (strstr(name, "/wapi/v1/SetConfig") != 0) {
		return (set_config(ptr_data_buf));
	}
	return 0;
}
void user_main(void)
{	
	uint8_t ret, rbuf[32];
	uint16_t len;
		
	printf("E14 Web Console %s(%s %s)\r\n", AppVersion, __DATE__, __TIME__);

	user_web_init(web_file_open);	//http://ip:5003
	serial_cfg.baudrate = get_serial_baudrate(RS485_PORT);
	serial_cfg.parity = get_serial_parity(RS485_PORT);
	serial_cfg.databits = get_serial_databits(RS485_PORT);
	serial_cfg.stopbits = get_serial_stopbits(RS485_PORT);	
	/*RS-485*/
	ret = serial_usart_open(USART_PORT_1, serial_cfg.baudrate, serial_cfg.parity, serial_cfg.databits, serial_cfg.stopbits);
	if (ret != USART_OK) {
		printf("usart_open failed:%d\r\n", ret);
		return;
	}
	ret = serial_usart_set_read_timeout(USART_PORT_1, 1); //1ms
	if (ret != USART_OK) {
		printf("serial_usart_set_read_timeout failed:%d\r\n", ret);
		return;
	}
	ret = serial_usart_set_write_timeout(USART_PORT_1, 1000); //1 second
	if (ret != USART_OK) {
		printf("serial_usart_set_write_timeout failed:%d\r\n", ret);
		return;
	}
	serial_usart_write(USART_PORT_1, "RS-485 Ready\r\n", 14);	
	for( ;; )
	{
		/*RS-485 echo*/
		len = serial_usart_read(USART_PORT_1, rbuf, 1);
		if (len > 0) {
			serial_usart_write(USART_PORT_1, rbuf, len);
		}		
		vTaskDelay(1);		
	}
}
