#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "asf.h"
#include "RIO2014_SYSTEM.h"
#include "RIO2014_Web.h"
#include "web_ajax.h"

#define POST_INFO_NUM	16
extern char dbg_msg[128];
struct val_post_stuct {
    char  *name;
    char  *string;	
	char   strlen;
};
static struct val_post_stuct get_post_info[POST_INFO_NUM];

struct net_settings {
	char lan_cfg;
	unsigned char lan_ip[4];
	unsigned char lan_nm[4];
	unsigned char lan_gw[4];
	unsigned char dns_pri[4];
	unsigned char dns_sec[4];
};

static struct net_settings net_cfg;
struct serial_settings serial_cfg;

static uint8_t parseIP(char *str, char *ip)
{
	char ipbuf[16], *pos, *ptr;
	signed short j;
	unsigned char i;

	if(!strcmp(str,"")){
		ip[0]=ip[1]=ip[2]=ip[3]=0;
		return 1;
	}
	if (strlen(str) > 15) {
		return 0;
	}
	sprintf(ipbuf, "%s", str);
	ptr = ipbuf;

	for(i=0; i<4; i++) {
		pos = strstr(ptr, ".");
		if (pos == NULL) {
			if (i != 3) {
				return 0;
			}
			} else {
			pos[0] = 0;//write 0x00 0, lead to reset
		}
		j = (signed short)strtoul(ptr, NULL, 10);

		if(j < 0 || j > 255) {
			return 0;
		}
		ip[i] = j;
		if (i == 3) {
			return 1;
		}

		ptr = pos + 1;
	}

	return 0;
}


static unsigned short GetPostCmd(char *postdata)
{
    unsigned short idx;
	char flag;
	char *pos, *str;
	unsigned char i;

	str = postdata;

	idx = 0;
	flag = 1;
	do {
		pos = strchr(str, '=');
		if (pos == 0) {
			break;
		}
		pos[0] = 0;
		get_post_info[idx].name = str;

		str = pos + 1;
		pos = strchr(str, '&');
		if (pos == 0) {
			flag = 0;
		} else {
			pos[0] = 0;
		}
		get_post_info[idx].string = str;	
		if (flag == 0) {
			for(i=0; i<40; i++) {
				if (str[i] == 0) {
					break;
				}
			}
			get_post_info[idx].strlen = i;
		} else {
			get_post_info[idx].strlen = pos-str;
		}
		idx++;
		if (flag) {
			pos++;
			str = pos;
		}
	} while(flag && (idx < POST_INFO_NUM));

	return (idx);
}

uint16_t fetch_config(char *ajax_buf_ptr)
{
	uint16_t len = 0;
	char val_str[8];
	
	net_cfg.lan_cfg = get_lan_cfg();
	get_lan_ip(net_cfg.lan_ip);
	get_lan_nm(net_cfg.lan_nm);
	get_lan_gw(net_cfg.lan_gw);
	get_lan_dns_pri(net_cfg.dns_pri);
	get_lan_dns_sec(net_cfg.dns_sec);

	len += sprintf(&ajax_buf_ptr[len], "%s", "{\"response\":[");
	len += sprintf(&ajax_buf_ptr[len], "{\"name\":\"ip_cfg\",\"val\":\"%u\"},",	(int)net_cfg.lan_cfg);		
	len += sprintf(&ajax_buf_ptr[len], "{\"name\":\"ip_ip\",\"val\":\"%u.%u.%u.%u\"},",
					(int)net_cfg.lan_ip[0], (int)net_cfg.lan_ip[1], (int)net_cfg.lan_ip[2], (int)net_cfg.lan_ip[3]);
	len += sprintf(&ajax_buf_ptr[len], "{\"name\":\"ip_nm\",\"val\":\"%u.%u.%u.%u\"},",
					(int)net_cfg.lan_nm[0], (int)net_cfg.lan_nm[1], (int)net_cfg.lan_nm[2], (int)net_cfg.lan_nm[3]);
	len += sprintf(&ajax_buf_ptr[len], "{\"name\":\"ip_gw\",\"val\":\"%u.%u.%u.%u\"},",
					(int)net_cfg.lan_gw[0], (int)net_cfg.lan_gw[1], (int)net_cfg.lan_gw[2], (int)net_cfg.lan_gw[3]);
	len += sprintf(&ajax_buf_ptr[len], "{\"name\":\"ip_dns_pri\",\"val\":\"%u.%u.%u.%u\"},",
					(int)net_cfg.dns_pri[0], (int)net_cfg.dns_pri[1], (int)net_cfg.dns_pri[2], (int)net_cfg.dns_pri[3]);
	len += sprintf(&ajax_buf_ptr[len], "{\"name\":\"ip_dns_sec\",\"val\":\"%u.%u.%u.%u\"},",
					(int)net_cfg.dns_sec[0], (int)net_cfg.dns_sec[1], (int)net_cfg.dns_sec[2], (int)net_cfg.dns_sec[3]);
	len += sprintf(&ajax_buf_ptr[len], "{\"name\":\"uart_baud\",\"val\":\"%ld\"},",
					serial_cfg.baudrate);
	if (serial_cfg.parity == US_MR_PAR_EVEN) {
		sprintf(val_str,"%s","EVEN");
	} else if (serial_cfg.parity == US_MR_PAR_ODD) {
		sprintf(val_str,"%s","ODD");
	} else if (serial_cfg.parity == US_MR_PAR_SPACE) {
		sprintf(val_str,"%s","SPACE");		
	} else if (serial_cfg.parity == US_MR_PAR_MARK) {
		sprintf(val_str,"%s","MARK");		
	} else {
		sprintf(val_str,"%s","NONE");		
	}
	len += sprintf(&ajax_buf_ptr[len], "{\"name\":\"uart_parity\",\"val\":\"%s\"},", val_str);		
	if (serial_cfg.databits == US_MR_CHRL_5_BIT) {
		sprintf(val_str,"%s","5");
	} else if (serial_cfg.databits == US_MR_CHRL_6_BIT) {
		sprintf(val_str,"%s","6");
	} else if (serial_cfg.databits == US_MR_CHRL_7_BIT) {
		sprintf(val_str,"%s","7");
	} else {
		sprintf(val_str,"%s","8");
	}		
	len += sprintf(&ajax_buf_ptr[len], "{\"name\":\"uart_dbits\",\"val\":\"%s\"},", val_str);			
	if (serial_cfg.stopbits == US_MR_NBSTOP_2_BIT) {
		sprintf(val_str,"%s","2");
	} else {
		sprintf(val_str,"%s","1");
	}		
	len += sprintf(&ajax_buf_ptr[len], "{\"name\":\"uart_sbits\",\"val\":\"%s\"}", val_str);	
	
	len += sprintf(&ajax_buf_ptr[len], "%s", "]}");
		
	return len;				   
}
uint16_t set_config(char *ajax_buf_ptr)
{
	uint16_t len = 0;
	uint8_t i, post_item, val;
	char tmp8[4];
	uint32_t tmp32;

	post_item = GetPostCmd(ajax_buf_ptr);
	for(i=0; i<post_item; i++) {
//printf("name:%s=%s\r\n", get_post_info[i].name, get_post_info[i].string);		
		if (strcmp(get_post_info[i].name, "ip_cfg") == 0) {
			val = atoi(get_post_info[i].string);
			if (val == 0 || val == 1) {
				set_lan_cfg(val);
			} else {
				len += sprintf(&ajax_buf_ptr[len], "%s", "ip_cfg=failed&");
			}
		} else if (strstr(get_post_info[i].name, "ip_") != 0) {
			if (parseIP(get_post_info[i].string, tmp8) != 1) {
				len += sprintf(&ajax_buf_ptr[len], "%s=failed&", get_post_info[i].name);
				continue;
			}
			if (strcmp(get_post_info[i].name, "ip_ip")==0) {
				if (set_lan_ip(get_post_info[i].string) != 0) {
					len += sprintf(&ajax_buf_ptr[len], "%s=failed&", get_post_info[i].name);
				}
			} else if (strcmp(get_post_info[i].name, "ip_nm")==0) {
				if (set_lan_nm(get_post_info[i].string) != 0) {
					len += sprintf(&ajax_buf_ptr[len], "%s=failed&", get_post_info[i].name);
				}
			} else if (strcmp(get_post_info[i].name, "ip_gw")==0) {
				if (set_lan_gw(get_post_info[i].string) != 0) {
					len += sprintf(&ajax_buf_ptr[len], "%s=failed&", get_post_info[i].name);
				}
			} else if (strcmp(get_post_info[i].name, "ip_dns_pri")==0) {
				if (set_lan_dns_pri(get_post_info[i].string) != 0) {
					len += sprintf(&ajax_buf_ptr[len], "%s=failed&", get_post_info[i].name);
				}
			} else if (strcmp(get_post_info[i].name, "ip_dns_sec")==0) {
				if (set_lan_dns_sec(get_post_info[i].string) != 0) {
					len += sprintf(&ajax_buf_ptr[len], "%s=failed&", get_post_info[i].name);
				}
			}
		} else if (strstr(get_post_info[i].name, "uart_") != 0) {			
			if (strcmp(get_post_info[i].name, "uart_baud")==0) {				
				tmp32 = strtoul(get_post_info[i].string, NULL, 10);		
				if (set_serial_baudrate(RS485_PORT, tmp32) != 0) {
					len += sprintf(&ajax_buf_ptr[len], "%s=failed&", get_post_info[i].name);
				}				
			} else if (strcmp(get_post_info[i].name, "uart_parity")==0) {
				if (strcmp(get_post_info[i].string, "NONE")==0) {
					tmp32 = US_MR_PAR_NO;
				} else if (strcmp(get_post_info[i].string, "EVEN")==0) {
					tmp32 = US_MR_PAR_EVEN;
				} else if (strcmp(get_post_info[i].string, "ODD")==0) {
					tmp32 = US_MR_PAR_ODD;				
				} else if (strcmp(get_post_info[i].string, "SPACE")==0) {
					tmp32 = US_MR_PAR_SPACE;
				} else if (strcmp(get_post_info[i].string, "MARK")==0) {
					tmp32 = US_MR_PAR_MARK;									
				} else {
					len += sprintf(&ajax_buf_ptr[len], "%s=failed&", get_post_info[i].name);
					break;
				}					
				if (set_serial_parity(RS485_PORT, tmp32) != 0) {
					len += sprintf(&ajax_buf_ptr[len], "%s=failed&", get_post_info[i].name);
				}				
			} else if (strcmp(get_post_info[i].name, "uart_dbits")==0) {
				if (strcmp(get_post_info[i].string, "5")==0) {
					tmp32 = US_MR_CHRL_5_BIT;
				} else if (strcmp(get_post_info[i].string, "6")==0) {
					tmp32 = US_MR_CHRL_6_BIT;
				} else if (strcmp(get_post_info[i].string, "7")==0) {
					tmp32 = US_MR_CHRL_7_BIT;
				} else if (strcmp(get_post_info[i].string, "8")==0) {
					tmp32 = US_MR_CHRL_8_BIT;
				} else {
					len += sprintf(&ajax_buf_ptr[len], "%s=failed&", get_post_info[i].name);
					break;
				}				
				if (set_serial_databits(RS485_PORT, tmp32) != 0) {
					len += sprintf(&ajax_buf_ptr[len], "%s=failed&", get_post_info[i].name);
				}
			} else if (strcmp(get_post_info[i].name, "uart_sbits")==0) {
				if (strcmp(get_post_info[i].string, "1")==0) {
					tmp32 = US_MR_NBSTOP_1_BIT;
				} else if (strcmp(get_post_info[i].string, "2")==0) {
					tmp32 = US_MR_NBSTOP_2_BIT;
				} else {
					len += sprintf(&ajax_buf_ptr[len], "%s=failed&", get_post_info[i].name);
					break;
				}	
				if (set_serial_stopbits(RS485_PORT, tmp32) != 0) {
					len += sprintf(&ajax_buf_ptr[len], "%s=failed&", get_post_info[i].name);
				}				
			}
		}
	}
	if (len == 0) {
		len = sprintf(&ajax_buf_ptr[len], "%s", "OK");
		save_settings_reboot();
	}
	return len;
}





