﻿/*
 * RIO2014_SPI_FLASH.h
 *
 * Created: 2015/8/30 下午 04:54:44
 *  Author: Ying
 */ 


#ifndef RIO2014_SPI_FLASH_H_
#define RIO2014_SPI_FLASH_H_

#define SPI_FLASH_OK	0x00
#define SPI_FLASH_ERR_TIMEOUT	0x01
#define SPI_FLASH_ERR_ARGUMENT	0x02
#define SPI_FLASH_ERR_OVERRUN	0x03
#define SPI_FLASH_ERR_MODE_FAULT	0x04
#define SPI_FLASH_ERR_OVERRUN_AND_MODE_FAULT	0x05
#define SPI_FLASH_ERR_ARG_BLOCK_NO	0x06
#define SPI_FLASH_ERR_ARG_SECTOR_NO	0x07
#define SPI_FLASH_ERR_ARG_LENGTH	0x08
#define SPI_FLASH_ERR_ARG_PAGE_NO	0x09
#define SPI_FLASH_ERR_ARG_ADDR		0x0A
#define SPI_FLASH_ERR_WAIT_READY_TIMEOUT	0x0B
#define SPI_FLASH_ERR_BUS_BUSY		0x0C

uint8_t spi_flash_init(void);
uint8_t spi_flash_erase_chip(void);
/*sector no: 0~511, sector size: 4Kbytes*/
uint8_t spi_flash_erase_sector(uint16_t sector_no);
/*block no: 0~31, block size: 64Kbytes*/
uint8_t spi_flash_erase_block(uint16_t block_no);
/*page no: 0~8191, page size: 256bytes*/
uint8_t spi_flash_write_page(uint16_t page_no, uint8_t *data_buf, uint16_t len);
uint8_t spi_flash_read(uint32_t start_address, uint8_t *data_buf, uint32_t len);

#endif /* RIO2014_SPI_FLASH_H_ */