﻿/*
 * RIO2014_SPI_SRAM.h
 *
 * Created: 2015/9/5 下午 05:06:22
 *  Author: Ying
 */ 


#ifndef RIO2014_SPI_SRAM_H_
#define RIO2014_SPI_SRAM_H_

#define SPI_SRAM_OK	0x00
#define SPI_SRAM_ERR_TIMEOUT	0x01
#define SPI_SRAM_ERR_ARGUMENT	0x02
#define SPI_SRAM_ERR_OVERRUN	0x03
#define SPI_SRAM_ERR_MODE_FAULT	0x04
#define SPI_SRAM_ERR_OVERRUN_AND_MODE_FAULT	0x05
#define SPI_SRAM_ERR_ARG_BLOCK_NO	0x06
#define SPI_SRAM_ERR_ARG_SECTOR_NO	0x07
#define SPI_SRAM_ERR_ARG_LENGTH	0x08
#define SPI_SRAM_ERR_ARG_PAGE_NO	0x09
#define SPI_SRAM_ERR_ARG_ADDR		0x0A
#define SPI_SRAM_ERR_WAIT_READY_TIMEOUT	0x0B
#define SPI_SRAM_ERR_BUS_BUSY		0x0C

uint8_t spi_sram_init(void);
uint8_t spi_sram_write(uint32_t start_address, uint8_t *data_buf, uint16_t len);
uint8_t spi_sram_read(uint32_t start_address, uint8_t *data_buf, uint32_t len);


#endif /* RIO2014_SPI_SRAM_H_ */